Mercurial > emacs
annotate admin/quick-install-emacs @ 52634:bb955cc088f9
Revision: miles@gnu.org--gnu-2003/emacs--cvs-trunk--0--patch-62
Tweaks to admin/quick-install-emacs
* quick-install-emacs: Remove fns-* pruning, since that file no
longer seems to be generated.
(AVOID): Quote literal periods. Quote braces in a way acceptable
to all parties (gawk gets bitchy about using `\').
author | Miles Bader <miles@gnu.org> |
---|---|
date | Sat, 27 Sep 2003 23:08:14 +0000 |
parents | 9e0c7158faae |
children | 8f70aecafdb5 |
rev | line source |
---|---|
39041 | 1 #!/bin/sh |
2 # quick-install-emacs -- do a halfway-decent job of installing emacs quickly | |
3 # Written by Miles Bader <miles@gnu.org> | |
4 | |
5 # This script is mainly intended for emacs maintainer or pretesters who | |
6 # install emacs very often. See the --help output for more details. | |
7 | |
8 PUBLIC_LIBSRC_BINARIES='b2m emacsclient etags ctags ebrowse' | |
9 PUBLIC_LIBSRC_SCRIPTS='grep-changelog rcs-checkin' | |
10 | |
52634
bb955cc088f9
Revision: miles@gnu.org--gnu-2003/emacs--cvs-trunk--0--patch-62
Miles Bader <miles@gnu.org>
parents:
52506
diff
changeset
|
11 AVOID="CVS -DIC README COPYING ChangeLog ~ [.]orig$ [.]rej$ Makefile makefile stamp-subdir [.]cvsignore [.]arch-ids [{]arch[}] [.][cho]$ make-docfile testfile test-distrib" |
39041 | 12 |
13 # Prune old binaries lying around in the source tree | |
14 PRUNE=no | |
15 # Re-install files even if they already exist | |
16 FORCE=no | |
17 # Command verbose flag | |
18 VERBOSE='' | |
19 | |
20 me="`basename $0`" | |
21 | |
22 # Install commands (these commands are also expected to understand the | |
23 # GNU -v (--verbose) option) | |
24 LINK='cp -lf' | |
25 COPY='cp -f' | |
26 REMOVE='rm -r' | |
27 | |
28 # Used to execute commands once once we create them | |
29 EXEC='sh' | |
30 MKDIR='mkdir --verbose -p' | |
31 | |
32 NAWK=/usr/bin/nawk | |
33 | |
49088
a22f8991ae27
Unset LANG etc. to avoid non-standard command output from non-C locales.
Miles Bader <miles@gnu.org>
parents:
45539
diff
changeset
|
34 # avoid non-standard command output from non-C locales |
a22f8991ae27
Unset LANG etc. to avoid non-standard command output from non-C locales.
Miles Bader <miles@gnu.org>
parents:
45539
diff
changeset
|
35 unset LANG LC_ALL LC_MESSAGES |
a22f8991ae27
Unset LANG etc. to avoid non-standard command output from non-C locales.
Miles Bader <miles@gnu.org>
parents:
45539
diff
changeset
|
36 |
39041 | 37 # Some messages |
38 USAGE="Usage: $me [OPTION...] BUILD_TREE [PREFIX]" | |
39 TRY="Try "\`"$me --help' for more information." | |
40 | |
41 # Parse command-line options | |
42 while :; do | |
43 case "$1" in | |
44 -n|--dry-run) | |
45 EXEC=cat; shift;; | |
46 -p|--prune) | |
47 PRUNE=yes; shift;; | |
48 -P|--no-prune) | |
49 PRUNE=no; shift;; | |
50 --prune-only) | |
51 PRUNE=only; shift;; | |
52 -f|--force) | |
53 FORCE=yes; shift;; | |
54 -v|--verbose) | |
55 VERBOSE="-v"; shift;; | |
56 --help) | |
57 cat <<EOF | |
58 $USAGE | |
59 Install emacs quickly | |
60 | |
61 -n, --dry-run print installation commands instead of | |
62 executing them | |
63 | |
64 -f, --force install even files that haven't changed | |
65 -v, --verbose print messages describing what is done | |
66 | |
67 -p, --prune prune old generated files | |
68 -P, --no-prune don't prune old generated files (default) | |
69 --prune-only prune old generated files, but don't install | |
70 | |
71 --help display this help and exit | |
72 --version output version information and exit | |
73 | |
74 $me install emacs \`incrementally,' that is, it will | |
75 install only those files that have changed since the last time it was | |
76 invoked, and remove any obsolete files from the installation | |
77 directories. It also uses hard-links into the source and build trees to | |
78 do the install, so it uses much less space than the default Makefile | |
79 install target; however, this also means that $me can | |
80 not install onto a disk partition other than the one on which the source | |
81 and build directories reside. | |
82 | |
83 Optionally, $me can also remove old versions of | |
84 automatically generated files that are version-specific (such as the | |
85 versioned emacs executables in the \`src' directory, and the DOC-* files | |
86 in the \`etc' directory). The latter action is called \`pruning,' and | |
87 can be enabled using the \`-p' or \`--prune' options. | |
88 EOF | |
89 exit 0 | |
90 ;; | |
91 --version) | |
92 cat <<EOF | |
49089 | 93 $me 1.6 |
39041 | 94 |
95 Written by Miles Bader <miles@gnu.org> | |
96 EOF | |
97 exit 0 | |
98 ;; | |
99 -[^-]?*) | |
100 # split concatenated single-letter options apart | |
101 FIRST="$1"; shift | |
102 set -- `echo $FIRST | sed 's/-\(.\)\(.*\)/-\1 -\2/'` "$@" | |
103 ;; | |
104 -*) | |
105 echo 1>&2 "$me: unrecognized option "\`"$1'" | |
106 echo 1>&2 "$TRY" | |
107 exit 1 | |
108 ;; | |
109 *) | |
110 break; | |
111 esac | |
112 done | |
113 | |
114 LINK_CMD="$LINK $VERBOSE" | |
115 REMOVE_CMD="$REMOVE $VERBOSE" | |
116 | |
117 case $# in | |
118 1) BUILD="$1";; | |
119 2) BUILD="$1"; prefix="$2";; | |
120 *) | |
121 echo 1>&2 "$USAGE" | |
122 echo 1>&2 "$TRY" | |
123 exit 1 | |
124 ;; | |
125 esac | |
126 | |
127 if test ! -d "$BUILD"; then | |
128 echo 1>&2 "$me: $BUILD: Build tree not found" | |
129 exit 2 | |
130 elif test ! -r "$BUILD/config.status"; then | |
131 echo 1>&2 "$me: $BUILD: Not a proper build tree, config.status not found" | |
132 exit 2 | |
133 fi | |
134 | |
135 CONFIG_STATUS="$BUILD/config.status" | |
136 function get_config_var () { | |
44112
271a4f9d12fc
(PRUNED): Avoid "head -1" and "tail +2", as POSIX 1003.1-2001
Paul Eggert <eggert@twinsun.com>
parents:
40064
diff
changeset
|
137 if ! sed -n "s/^s\(.\)@$1@\1\(.*\)\1.*$/\2/p" $CONFIG_STATUS | sed q | grep '' |
39041 | 138 then |
139 echo 1>&2 "$me: $1: Configuration variable not found in $CONFIG_STATUS" | |
140 exit 4 | |
141 fi | |
142 } | |
143 | |
40064
90451d9e7e0e
Exit if we can't find some variable.
Miles Bader <miles@gnu.org>
parents:
39041
diff
changeset
|
144 test x"$SRC" = x && { SRC="`get_config_var srcdir`" || exit 4 ; } |
90451d9e7e0e
Exit if we can't find some variable.
Miles Bader <miles@gnu.org>
parents:
39041
diff
changeset
|
145 test x"$prefix" = x && { prefix="`get_config_var prefix`" || exit 4 ; } |
90451d9e7e0e
Exit if we can't find some variable.
Miles Bader <miles@gnu.org>
parents:
39041
diff
changeset
|
146 test x"$ARCH" = x && { ARCH="`get_config_var host`" || exit 4 ; } |
39041 | 147 |
45539
99b2cc9b795c
(VERSION): Calculate using the same method that configure.in uses.
Miles Bader <miles@gnu.org>
parents:
44112
diff
changeset
|
148 VERSION=`grep 'defconst[ ]*emacs-version' $SRC/lisp/version.el \ |
99b2cc9b795c
(VERSION): Calculate using the same method that configure.in uses.
Miles Bader <miles@gnu.org>
parents:
44112
diff
changeset
|
149 | sed -e 's/^[^"]*"\([^"]*\)".*$/\1/'` |
99b2cc9b795c
(VERSION): Calculate using the same method that configure.in uses.
Miles Bader <miles@gnu.org>
parents:
44112
diff
changeset
|
150 |
39041 | 151 DST_SHARE="$prefix/share/emacs/$VERSION" |
152 DST_BIN="$prefix/bin" | |
153 DST_LIBEXEC="$prefix/libexec/emacs/$VERSION/$ARCH" | |
154 DST_INFO="$prefix/info" | |
155 | |
156 function maybe_mkdir () { | |
157 if ! test -d "$1"; then | |
158 $MKDIR "$1" 2>&1 | sed "s/^mkdir:/$me:/" 1>&2 | |
159 fi | |
160 } | |
161 | |
162 maybe_mkdir "$DST_BIN" | |
163 maybe_mkdir "$DST_SHARE" | |
164 maybe_mkdir "$DST_SHARE/site-lisp" | |
165 maybe_mkdir "$DST_LIBEXEC" | |
166 maybe_mkdir "$DST_INFO" | |
167 | |
168 ( # start of command-generating sub-shell | |
169 | |
170 PRUNED="" | |
171 if test x"$PRUNE" != xno; then | |
44112
271a4f9d12fc
(PRUNED): Avoid "head -1" and "tail +2", as POSIX 1003.1-2001
Paul Eggert <eggert@twinsun.com>
parents:
40064
diff
changeset
|
172 for D in `ls -1t $BUILD/etc/DOC-* | sed 1d`; do |
39041 | 173 echo $REMOVE_CMD $D |
174 PRUNED="$PRUNED $D" | |
175 done | |
44112
271a4f9d12fc
(PRUNED): Avoid "head -1" and "tail +2", as POSIX 1003.1-2001
Paul Eggert <eggert@twinsun.com>
parents:
40064
diff
changeset
|
176 for D in `ls -1t $BUILD/src/emacs-$VERSION.* | sed 1d`; do |
39041 | 177 echo $REMOVE_CMD $D |
178 PRUNED="$PRUNED $D" | |
179 done | |
180 fi | |
181 | |
182 test x"$PRUNE" = xonly && exit 0 | |
183 | |
184 function maybe_emit_copy () { | |
185 if test "$FORCE" = yes || ! cmp -s $1 $2; then | |
186 echo $LINK_CMD $1 $2 | |
187 fi | |
188 } | |
189 | |
190 maybe_emit_copy $BUILD/src/emacs $DST_BIN/emacs | |
191 maybe_emit_copy $BUILD/src/emacs $DST_BIN/emacs-$VERSION | |
192 | |
193 for F in $PUBLIC_LIBSRC_BINARIES; do | |
194 maybe_emit_copy $BUILD/lib-src/$F $DST_BIN/$F | |
195 done | |
196 for F in $PUBLIC_LIBSRC_SCRIPTS; do | |
197 maybe_emit_copy $SRC/lib-src/$F $DST_BIN/$F | |
198 done | |
199 | |
200 if test x"$SRC" = x"$BUILD"; then | |
201 PFXS="$BUILD" | |
202 else | |
203 PFXS="$SRC $BUILD" | |
204 fi | |
205 | |
206 for SUBDIR in lisp leim etc lib-src info; do | |
207 # defaults | |
208 SHARED=no | |
209 FORCED='' | |
210 AVOID_PAT="`echo "($AVOID)" | tr ' ' '|'`" | |
211 | |
212 # Set subdir-specific values | |
213 case $SUBDIR in | |
214 lisp|leim) | |
215 DST="$DST_SHARE/$SUBDIR" | |
216 ;; | |
217 etc) | |
218 DST="$DST_SHARE/$SUBDIR" | |
219 # COPYING is in the avoid list, but there should be a copy of it in | |
220 # the install etc dir, so make that here. | |
221 FORCED="$DST/COPYING" | |
222 ;; | |
223 lib-src) | |
224 DST="$DST_LIBEXEC" | |
225 AVOID_PAT="`echo "($AVOID ($PUBLIC_LIBSRC_BINARIES $PUBLIC_LIBSRC_SCRIPTS)\$)" | tr ' ' '|'`" | |
226 ;; | |
227 info) | |
228 DST="$DST_INFO" | |
229 SHARED=yes | |
230 ;; | |
231 esac | |
232 | |
233 for PFX in $PFXS; do | |
234 if [ -d $PFX/$SUBDIR ]; then | |
235 for DIR in `(cd $PFX/$SUBDIR; find . -type d -print | sed 's@^./@@')`; do | |
236 if [ -d $DST/$DIR ]; then | |
237 echo Directory $DST/$DIR exists | |
238 else | |
239 echo Directory $DST/$DIR non-existant | |
240 if [ "`echo $DIR | egrep -v "$AVOID_PAT"`" ]; then | |
241 maybe_mkdir $DST/$DIR | |
242 fi | |
243 fi | |
244 done | |
245 diff -sqr $PFX/$SUBDIR $DST | |
246 fi | |
247 done | $NAWK ' | |
248 BEGIN { | |
249 src_pat = "^'"$SRC"'/'"$SUBDIR"'/" | |
250 build_pat = "^'"$BUILD"'/'"$SUBDIR"'/" | |
251 dst_pat = "^'"$DST"'/" | |
252 dst_pfx = "'"$DST"'/" | |
253 avoid_pat = "'"$AVOID_PAT"'" | |
254 force = ("'"$FORCE"'" == "yes") | |
255 shared = ("'"$SHARED"'" == "yes") | |
256 init_bool_array(pruned, "'"$PRUNED"'") | |
257 init_bool_array(forced, "'"$FORCED"'") | |
258 } | |
259 function init_bool_array(array, string, a,k) | |
260 { | |
261 split (string, a) | |
262 for (k in a) | |
263 array[a[k]] = 1 | |
264 } | |
265 function install(src, dst) | |
266 { | |
267 if (! (src in pruned)) { | |
268 cp[src] = dst; | |
269 from[dst] = src; | |
270 delete rm[dst]; | |
271 } | |
272 } | |
273 function update(src, dst, copy) | |
274 { | |
275 if (src in pruned) { | |
276 rm[dst] = 1; | |
277 delete from[dst] | |
278 } else { | |
279 if (copy) | |
280 cp[src] = dst; | |
281 from[dst] = src; | |
282 delete rm[dst]; | |
283 } | |
284 } | |
285 function uninstall(dst) | |
286 { | |
287 if (!(dst in from)) | |
288 rm[dst] = 1; | |
289 } | |
290 /^Directory / { | |
291 if ($2 ~ avoid_pat) { | |
292 if ($NF == "exists") | |
293 uninstall($2) | |
294 } else | |
295 update(0, $2, 0) | |
296 next | |
297 } | |
298 /^Files / { | |
299 if ($4 ~ avoid_pat && !($4 in forced)) | |
300 uninstall($4) | |
301 else if ($NF == "identical") | |
302 update($2, $4, force) | |
303 else | |
304 update($2, $4, 1) | |
305 next | |
306 } | |
307 /^Only / { | |
308 pfx = $3 | |
309 sub (/:$/, "/", pfx) | |
310 | |
311 if (pfx ~ dst_pat) { | |
312 if (! shared) | |
313 uninstall(pfx $4) | |
314 } else { | |
315 subdir = pfx | |
316 if (subdir ~ src_pat) | |
317 sub (src_pat, "", subdir) | |
318 else | |
319 sub (build_pat, "", subdir) | |
320 | |
321 dst = dst_pfx subdir $4 | |
322 if (! (dst ~ avoid_pat)) | |
323 install(pfx $4, dst) | |
324 } | |
325 next | |
326 } | |
327 END { | |
328 for (f in rm) | |
329 print "'"$REMOVE_CMD"' " f | |
330 for (f in cp) | |
331 print "'"$LINK_CMD"' " f " " cp[f] | |
332 } | |
333 ' | |
334 done | |
335 | |
336 ) | eval $EXEC | |
52401 | 337 |
338 # arch-tag: 9322b572-9755-4cf7-a67a-21e6505f1477 |